#include "inkey.ch"
#include "common.ch"
#include "activex.ch"

#DEFINE olFolderCalendar   9

   REQUEST DBFCDX
*  REQUEST DBFNTX

FUNCTION HB_GTSYS()
    REQUEST HB_GT_WIN_DEFAULT           // Console
RETURN NIL

PROCEDURE MAIN
LOCAL cAppPath  := LEFT( APPNAME( .t. ), LEN( APPNAME( .t. ) ) - LEN( APPNAME( .f. ) ) )
LOCAL zDBF      := cAppPath + "CALENDAR.DBF"
LOCAL cStart
LOCAL cEnd
LOCAL nMax := 25 // MAXROW()
LOCAL nCol := 80 // MAXCOL()
LOCAL Getlist := {}

   RddSetDefault( "DBFCDX" )

   SET EPOCH TO YEAR( DATE() ) - 50
   SET CENTURY on
   SET DATE GERMAN

   cStart     := "01.01.2020"
   cEnd       := DTOC(DATE())   // +" 0:01 AM"

   SELECT 1

   // create DBF
   //
   IF !FILE( zDBF )
      CRE_CALENDAR( zDBF )
   ENDIF

   // create Index
   //
   IF FILE(  STRTRAN(zDBF,".DBF",".CDX") )
      FERASE(STRTRAN(zDBF,".DBF",".CDX") )
   ENDIF
   IF !FILE( STRTRAN(zDBF,".DBF",".CDX") )
      CRE_INDEX(zDBF)
   ENDIF

   USE ( zDBF ) EXCLUSIVE
*   SET INDEX TO (STRTRAN(zDBF,".DBF",".CDX"))
*   OrdSetFocus(0)
   ZAP

   CLS

*   @ (nMax/2)-1,(nCol/2) SAY "Show from "
*   @ (nMax/2)  ,(nCol/2) SAY "Start Date" GET cStart
*   @ (nMax/2)+1,(nCol/2) SAY "End   Date" GET cEnd
*
*   READ
*   CLEAR GETS

   SET ALTER TO DATETIME.TXT
   Fillit(cStart,cEnd)
   SET ALTER TO

   GO TOP
   Browse()

RETURN

PROCEDURE Fillit(cStart,cEnd)
LOCAL oOutlook
LOCAL oNameSpace
LOCAL oAppointment
LOCAL currentAppointment
LOCAL i,iMax
LOCAL oItem
LOCAL cStringStart
LOCAL cDateStart
LOCAL cTimeStart
LOCAL nRMBS
LOCAL bSaveError
LOCAL oError
LOCAL nMax := MAXROW()
LOCAL nCol := MAXCOL()
LOCAL cFilter
LOCAL cMax
LOCAL aDateSec
LOCAL nTimeStart
LOCAL nEndStart
LOCAL cText
LOCAL nHit  := 0
LOCAL nMiss := 0

   oOutlook := CreateObject( "Outlook.Application" )
   IF Empty(oOutLook)
      RETURN
   ENDIF

   oNameSpace   := oOutlook:GetNamespace( "MAPI" )

   cFilter      := "[Start] >= '"+ cStart + "' and [Start] <= '"+ cEnd +"'"
   oAppointment := oNameSpace:getDefaultFolder( olFolderCalendar ):Items

   #IFDEF USEFIND
      currentAppointment := oAppointment:Find(cFilter)
   #ELSE
      currentAppointment := oAppointment:Restrict(cFilter)
   #ENDIF

   iMax := currentAppointment:count()
   cMax := LTRIM(STR(iMax))

   nTimeStart  := SECONDS()

*   bSaveError  := ErrorBlock( {|oError| MyErrorHandler(oError) })

#IFDEF USEFIND
   i = 0
   DO While NIL <> currentAppointment
       oItem   := currentAppointment
       i++
#ELSE
   FOR i := 1 TO iMax
       oItem   := currentAppointment:item(i)
#ENDIF

      APPEND BLANK

      // will work
      //
      BEGIN SEQUENCE
         LogMe("1 Start")

ALTD()
         cStringStart := DTOS(oItem:Start)

         LogMe("2 Start "+ cStringStart)

         // GERMAN Notation
         //
*        cDateStart   := SUBSTR( cStringStart, 1, 8 )  // YYYYMMDDHHMMSS
         cDateStart   := cStringStart

         REPLACE CALENDAR->STARTDATE   WITH STOD(cDateStart)

         cTimeStart   := SUBSTR( cStringStart, 9, 2 ) + ":" + SUBSTR( cStringStart, 11, 2 ) + ":" + SUBSTR( cStringStart, 13, 2+4 )
         REPLACE CALENDAR->STARTTIME   WITH cTimeStart

         nHit++
      RECOVER USING oError
         nMiss++
         cStringStart := ""
         LogMe("0 Start                      FAIL")
      END SEQUENCE

      @ nMax,nCol/3 SAY cMax+"/"+STR(i)+" "+cStringStart

      BEGIN SEQUENCE

         // immer MUST !!! sonst "defekt" ?
         //
         LogMe("1 CreationTime")

         cStringStart := DTOC(oItem:CreationTime)

         LogMe("2 CreationTime"+cStringStart)
         REPLACE CALENDAR->CREDATE     WITH cStringStart

         nHit++
      RECOVER USING oError
         nMiss++
         LogMe("0 CreationTime               FAIL")
      END SEQUENCE

      BEGIN SEQUENCE

         // immer MUST !!! sonst "defekt" ?
         //
         LogMe("1 LastModificationTime")

         cStringStart := DTOC(oItem:LastModificationTime)

         LogMe("2 LastModificationTime"+cStringStart)
         REPLACE CALENDAR->LASTDATE    WITH cStringStart

         nHit++
      RECOVER USING oError
         nMiss++
         LogMe("0 LastModificationTime       FAIL")
      END SEQUENCE

      // "normale" Property
      //
      BEGIN SEQUENCE

         // meisten nicht ?
         //
         REPLACE CALENDAR->EVENTID     WITH VAL(hb_valToExp(oItem:EntryID))

*        nHit++
      RECOVER USING oError
         REPLACE CALENDAR->EVENTID     WITH (i+1000000)
      END SEQUENCE

      BEGIN SEQUENCE

         // immer
         //
         REPLACE CALENDAR->SUBJECT     WITH oItem:Subject

         nHit++
      RECOVER USING oError
         nMiss++
         LogMe("0 Subject                    FAIL")
      END SEQUENCE

      BEGIN SEQUENCE

         // immer, nur wenn Eintrag ;)
         //
         REPLACE CALENDAR->LOCATION    WITH oItem:Location

         nHit++
      RECOVER USING oError
         nMiss++
         LogMe("0 Location                   FAIL")
      END SEQUENCE

      BEGIN SEQUENCE

         // immer, nur wenn Eintrag ;)
         //
         REPLACE CALENDAR->LABELCOLOR  WITH oItem:Categories

         nHit++
      RECOVER USING oError
         nMiss++
         LogMe("0 Categories                 FAIL")
      END SEQUENCE

      BEGIN SEQUENCE

         // immer, nur wenn Eintrag ;)
         //
       REPLACE CALENDAR->MEMOTEXT   WITH oItem:Body

         nHit++
      RECOVER USING oError
         nMiss++
         LogMe("0 Body                       FAIL")
      END SEQUENCE

      BEGIN SEQUENCE

         // immer
         //
         REPLACE CALENDAR->Duration    WITH oItem:Duration
         nHit++
      RECOVER USING oError
         nMiss++
         LogMe("0 Duration                   FAIL")
      END SEQUENCE

      BEGIN SEQUENCE

         // immer, nur wenn Eintrag ;)
         //
         REPLACE CALENDAR->ALLDAY      WITH oItem:AllDayEvent
         nHit++
      RECOVER USING oError
         nMiss++
         LogMe("0 AllDayEvent                FAIL")
      END SEQUENCE

      BEGIN SEQUENCE

         // auch z.b. Geburtstag 1956 !!!
         //
         REPLACE CALENDAR->RECURREN    WITH oItem:RecurrenceState
         nHit++
      RECOVER USING oError
         nMiss++
         LogMe("0 RecurrenceState            FAIL")
      END SEQUENCE

      BEGIN SEQUENCE

         // fast immer default Wert
         //
         nRMBS := oItem:ReminderMinutesBeforeStart

         // hm ... berlauf ...
         //
         IF nRMBS > 999
            nRMBS := 999
         ENDIF
         REPLACE CALENDAR->WARNTIME    WITH nRMBS
         nHit++
      RECOVER USING oError
         nMiss++
         LogMe("0 ReminderMinutesBeforeStart FAIL")
      END SEQUENCE

      // hm ... works
      //
      BEGIN SEQUENCE

         // numerisch weil OUTLOOK.CH Konstante
         //
         REPLACE CALENDAR->BUSYSTAT    WITH oItem:BusyStatus
         nHit++
      RECOVER USING oError
         nMiss++
         LogMe("0 BusyStatus                 FAIL")
      END SEQUENCE

      BEGIN SEQUENCE

         // numerisch weil OUTLOOK.CH Konstante
         //
         REPLACE CALENDAR->IMPORTAN    WITH oItem:Importance
         nHit++
      RECOVER USING oError
         nMiss++
         LogMe("0 Importance                 FAIL")
      END SEQUENCE

      BEGIN SEQUENCE

         // numerisch weil OUTLOOK.CH Konstante
         //
         REPLACE CALENDAR->REMINDER    WITH oItem:ReminderSet
         nHit++
      RECOVER USING oError
         nMiss++
         LogMe("0 ReminderSet                FAIL")
      END SEQUENCE

      // hm ... 0
      //
      BEGIN SEQUENCE

         // testen
         //
         REPLACE CALENDAR->MEETING     WITH oItem:MeetingStatus
         nHit++
      RECOVER USING oError
         nMiss++
         LogMe("0 MeetingStatus              FAIL")
      END SEQUENCE

      BEGIN SEQUENCE

         // testen
         //
         REPLACE CALENDAR->PRIVATE     WITH oItem:Sensitivity
         nHit++
      RECOVER USING oError
         nMiss++
         LogMe("0 Sensitivity                FAIL")
      END SEQUENCE

#IFDEF USEFIND
      currentAppointment := oAppointment:FindNext
   ENDDO
#ELSE
   NEXT
#ENDIF

   CLS
   ? ""
   ? ""

   nEndStart   := SECONDS()
   SET DECIMALS TO 4

#IFDEF USEFIND
   ? cText := STR(nEndStart-nTimeStart)+" Sec. for "+LTRIM(STR(iMax))+" Records"
   LogMe(cText)
   IF iMax > 0
      ? cText := STR((nEndStart-nTimeStart)/iMax)+" Records per Sec."
      LogMe(cText)

      ? cText := STR((nEndStart-nTimeStart)/nHit)+" Sec. per activeX Calls"
      LogMe(cText)

      ? cText := STR(nMiss)+" ActiveX Calls fail"
      LogMe(cText)
   ENDIF
#ELSE
   ? cText := STR(nEndStart-nTimeStart)+" Sec. for "+LTRIM(STR(i))+" Records"
   LogMe(cText)
   IF i > 0
      ? cText := STR((nEndStart-nTimeStart)/i)+" Records per Sec."
      LogMe(cText)

      ? cText := STR((nEndStart-nTimeStart)/nHit)+" Sec. per ActiveX Calls"
      LogMe(cText)

      ? cText := STR(nMiss)+" ActiveX Calls fail"
      LogMe(cText)
   ENDIF
#ENDIF

   ? ""
   ? ""
   ? ""

   BEGIN SEQUENCE
      oOutlook  := NIL
   RECOVER USING oError
   END SEQUENCE

*   ErrorBlock( bSaveError )

RETURN

FUNCTION MyErrorHandler()    // Fehler-Routine
   BREAK
RETURN .F.


STATIC FUNCTION CRE_CALENDAR( datei, alias, id )
LOCAL p, field_list := {}

   IF VALTYPE( datei ) != "C"
      datei := "CALENDAR.DBF"
   ENDIF
   IF VALTYPE( alias ) != "C"
      p := AT( ".", datei )
      alias := IF( p > 0, SUBSTR( datei, 1, p - 1 ), datei )
   ENDIF
   IF VALTYPE( id ) != "N"
      id := 0
   ENDIF
   SELECT( id )
   IF !FILE( datei )
      AADD( field_list, { "EVENTID"    , "N",   7, 0 } )  // 9.999.999 Item enough ?
      AADD( field_list, { "CREDATE"    , "C",  14, 0 } )  // YYYYMMDDHHMMSS
      AADD( field_list, { "LASTDATE"   , "C",  14, 0 } )

      AADD( field_list, { "SUBJECT"    , "C", 100, 0 } )
      AADD( field_list, { "LOCATION"   , "C", 100, 0 } )
      AADD( field_list, { "STARTDATE"  , "D",   8, 0 } )
      AADD( field_list, { "STARTTIME"  , "C",   8, 0 } )
*     AADD( field_list, { "ENDDATE"    , "D",   8, 0 } )
*     AADD( field_list, { "ENDTIME"    , "C",   8, 0 } )
      AADD( field_list, { "DURATION"   , "N",   5, 0 } )
      AADD( field_list, { "ALLDAY"     , "L",   1, 0 } )
      AADD( field_list, { "LABELCOLOR" , "C",  20, 0 } )
*     aadd( field_list, { "LABELTEXT"  , "C",  30, 0 } )
      AADD( field_list, { "PRIVATE"    , "N",   3, 0 } )
      AADD( field_list, { "MEETING"    , "N",   3, 0 } )
      AADD( field_list, { "REMINDER"   , "L",   1, 0 } )
      AADD( field_list, { "WARNTIME"   , "N",   3, 0 } )
*     AADD( field_list, { "REMINDTIME" , "C",  14, 0 } )
*     AADD( field_list, { "SCHEDULE"   , "N",   3, 0 } )
*     aadd( field_list, { "SHOWTIMEAS" , "C",  30, 0 } )
      AADD( field_list, { "IMPORTAN"   , "N",   3, 0 } )
      AADD( field_list, { "BUSYSTAT"   , "N",   3, 0 } )
      AADD( field_list, { "RECURREN"   , "N",   3, 0 } )  // RecurrenceState only

      //
      // just for mark Record as deleted
      //
      AADD( field_list, { "MARKDEL"    , "L",   1, 0 } )  // is Record deleted
      //
      // Memofields
      //
      AADD( field_list, { "MEMOTEXT"   , "M",  10, 0 } )
*     AADD( field_list, { "MAKEUP"     , "M",  10, 0 } )  // XML MarkUp

      DBCREATE( datei, field_list, "DBFCDX" )

   ENDIF

RETURN .T.

STATIC FUNCTION CRE_INDEX(zDBF)
LOCAL _tagname
LOCAL _keyfeld
LOCAL _cdxname

   _cdxname := STRTRAN(zDBF,".DBF",".CDX")

   *# SNAPCODE USE CALENDAR.DBF
*  USE (zDBF) VIA "DBFCDX" EXCLUSIVE
   USE (zDBF) EXCLUSIVE

   INDEX ON EVENTID TAG "ID" TO &(_cdxname)

*   INDEX ON (DTOS(STARTDATE)+STRTRAN(STARTTIME,':','')) TAG "MYSTART" TO &(_cdxname)
*   INDEX ON STRTRAN(STARTTIME,':','') TAG "MYSTART" TO &(_cdxname)
   INDEX ON DTOS(STARTDATE) TAG "MYSTART" TO &(_cdxname)

   INDEX ON SUBJECT TAG "SUBJECT" TO &(_cdxname)
   INDEX ON IF( MARKDEL,'Y','N') TAG "MARKDEL" TO &(_cdxname)

/*********************************************************************
   //
   // index on EVENTID
   //
   _tagname := "ID"
   _KEYFELD := "EVENTID"
   ORDCREATE(_cdxname,_tagname,_keyfeld)
*   CLOSE INDEX

   _tagname := "STARTDATE"
   _KEYFELD := "DTOS( Startdate ) + STRTRAN( Starttime, ':', '' )"
   ORDCREATE(_cdxname,_tagname,_keyfeld)
*   CLOSE INDEX

   _tagname := "SUBJECT"
   _KEYFELD := "SUBJECT"
   ORDCREATE(_cdxname,_tagname,_keyfeld)
*   CLOSE INDEX

   //
   // index on "markdel" Flag to "recycle" Records
   //
   _tagname := "MARKDEL"
   _KEYFELD := "IF( MARKDEL = .T., 'Y', 'N' )"
   ORDCREATE(_cdxname,_tagname,_keyfeld)
   CLOSE INDEX

*********************************************************************/

   CLOSE

RETURN ( .t. )

STATIC FUNCTION LogMe(cText)
   SET ALTER ON
   SET CONSOLE OFF

   ? DATE(),TIME(),cText

   SET CONSOLE ON
   SET ALTER OFF

RETURN nil

STATIC FUNCTION AppName( lWithPath )
   LOCAL n
   LOCAL cName := hb_argV( 0 )
   //
   DEFAULT lWithPath TO .f.
   //
   IF !( lWithPath )
      IF ( n := rat( '\', cName ) ) > 0
         cName := substr( cName, n+1 )
      ENDIF
   ENDIF
   //
   RETURN  cName

*STATIC FUNCTION MsgBox( cMessage, cTitle )
*   RETURN Win_MessageBox( , cMessage, cTitle )

*STATIC FUNCTION AltD()
*   RETURN nil


*
*
*
